diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/random-variable-stream-test-suite.cc ns-3.32/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.31/src/core/test/random-variable-stream-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/random-variable-stream-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -2463,13 +2010,7 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  double sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Zipfly distributed random variable is equal to
@@ -2502,52 +2043,47 @@
   double expectedMean = 1.0;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for Zeta distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamZetaTestCase : public TestCase
+/**
+ * Test case for Zeta distribution random variable stream generator
+ */
+class ZetaTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamZetaTestCase ();
-  virtual ~RandomVariableStreamZetaTestCase ();
+  // Constructor
+  ZetaTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamZetaTestCase::RandomVariableStreamZetaTestCase ()
-  : TestCase ("Zeta Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamZetaTestCase::~RandomVariableStreamZetaTestCase ()
+ZetaTestCase::ZetaTestCase ()
+  : TestCaseBase ("Zeta Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamZetaTestCase::DoRun (void)
+ZetaTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   double alpha = 5.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ZetaRandomVariable> x = CreateObject<ZetaRandomVariable> ();
   x->SetAttribute ("Alpha", DoubleValue (alpha));
 
   // Calculate the mean of these values.
-  double sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // zetaly distributed random variable is equal to
@@ -2566,39 +2102,40 @@
     gsl_sf_zeta_int (static_cast<int> (alpha)       );
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic Zeta distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamZetaAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic Zeta distribution random variable stream generator
+ */
+class ZetaAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamZetaAntitheticTestCase ();
-  virtual ~RandomVariableStreamZetaAntitheticTestCase ();
+  // Constructor
+  ZetaAntitheticTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamZetaAntitheticTestCase::RandomVariableStreamZetaAntitheticTestCase ()
-  : TestCase ("Antithetic Zeta Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamZetaAntitheticTestCase::~RandomVariableStreamZetaAntitheticTestCase ()
+ZetaAntitheticTestCase::ZetaAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Zeta Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamZetaAntitheticTestCase::DoRun (void)
+ZetaAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   double alpha = 5.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ZetaRandomVariable> x = CreateObject<ZetaRandomVariable> ();
@@ -2608,13 +2145,7 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  double sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // zetaly distributed random variable is equal to
@@ -2633,37 +2164,34 @@
     gsl_sf_zeta_int (static_cast<int> (alpha)       );
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for deterministic random variable stream generator
-// ===========================================================================
-class RandomVariableStreamDeterministicTestCase : public TestCase
+/**
+ * Test case for deterministic random variable stream generator
+ */
+class DeterministicTestCase : public TestCaseBase
 {
 public:
-  static const double TOLERANCE;
-
-  RandomVariableStreamDeterministicTestCase ();
-  virtual ~RandomVariableStreamDeterministicTestCase ();
+  // Constructor
+  DeterministicTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
+  
+  /** Tolerance for testing rng values against expectation. */
+  static constexpr double TOLERANCE {1e-8};
 };
 
-const double RandomVariableStreamDeterministicTestCase::TOLERANCE = 1e-8;
-
-RandomVariableStreamDeterministicTestCase::RandomVariableStreamDeterministicTestCase ()
-  : TestCase ("Deterministic Random Variable Stream Generator")
-{}
-
-RandomVariableStreamDeterministicTestCase::~RandomVariableStreamDeterministicTestCase ()
+DeterministicTestCase::DeterministicTestCase ()
+  : TestCaseBase ("Deterministic Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamDeterministicTestCase::DoRun (void)
+DeterministicTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   Ptr<DeterministicRandomVariable> s = CreateObject<DeterministicRandomVariable> ();
@@ -2712,31 +2240,34 @@
   value = s->GetValue ();
 }
 
-// ===========================================================================
-// Test case for empirical distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamEmpiricalTestCase : public TestCase
+/**
+ * Test case for empirical distribution random variable stream generator
+ */
+class EmpiricalTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamEmpiricalTestCase ();
-  virtual ~RandomVariableStreamEmpiricalTestCase ();
+  // Constructor
+  EmpiricalTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
+  
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};
 };
 
-RandomVariableStreamEmpiricalTestCase::RandomVariableStreamEmpiricalTestCase ()
-  : TestCase ("Empirical Random Variable Stream Generator")
-{}
-
-RandomVariableStreamEmpiricalTestCase::~RandomVariableStreamEmpiricalTestCase ()
+EmpiricalTestCase::EmpiricalTestCase ()
+  : TestCaseBase ("Empirical Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamEmpiricalTestCase::DoRun (void)
+EmpiricalTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   // Create the RNG with a uniform distribution between 0 and 10.
@@ -2754,31 +2285,44 @@
                               "Incorrect value returned, expected only 5 or 10.");
     }
 
-  // Calculate the mean of the interpolated values.
-  double sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      double value = x->Interpolate ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  // Calculate the mean of the sampled values.
+  double valueMean = Average (x);
+
+  // The expected distribution with sampled values is
+  //     Value     Probability
+  //      5        25%
+  //     10        75%
+  //
+  // The expected mean is
+  //
+  //     E[value]  =  5 * 25%  +  10 * 75%  =  8.75
+  //
+  // Test that values have approximately the right mean value.
+  double expectedMean = 8.75;
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
+ 
 
+  // Calculate the mean of the interpolated values.
+  x->SetInterpolate (true);
+  valueMean = Average (x);
+ 
   // The expected distribution (with interpolation) is
-  //     Domain     Probability
+  //     Bin     Probability
   //     [0, 5)     25%
   //     [5, 10)    75%
   //
-  // The expected value for the mean of the values returned by this
-  // empirical distribution is
+  // Each bin is uniformly sampled, so the average of the samples in the
+  // bin is the center of the bin.
+  //
+  // The expected mean is
   //
   //     E[value]  =  2.5 * 25% + 7.5 * 75% = 6.25
   //
-  double expectedMean = 6.25;
+  expectedMean = 6.25;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
-
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
+ 
   // Bug 2082: Create the RNG with a uniform distribution between -1 and 1.
   Ptr<EmpiricalRandomVariable> y = CreateObject<EmpiricalRandomVariable> ();
   y->SetInterpolate (false);
@@ -2788,31 +2332,34 @@
   NS_TEST_ASSERT_MSG_LT (y->GetValue (), 2, "Empirical variable with negative domain");
 }
 
-// ===========================================================================
-// Test case for antithetic empirical distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamEmpiricalAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic empirical distribution random variable stream generator
+ */
+class EmpiricalAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamEmpiricalAntitheticTestCase ();
-  virtual ~RandomVariableStreamEmpiricalAntitheticTestCase ();
+  // Constructor
+  EmpiricalAntitheticTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
+  
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};
 };
 
-RandomVariableStreamEmpiricalAntitheticTestCase::RandomVariableStreamEmpiricalAntitheticTestCase ()
-  : TestCase ("EmpiricalAntithetic Random Variable Stream Generator")
-{}
-
-RandomVariableStreamEmpiricalAntitheticTestCase::~RandomVariableStreamEmpiricalAntitheticTestCase ()
+EmpiricalAntitheticTestCase::EmpiricalAntitheticTestCase ()
+  : TestCaseBase ("EmpiricalAntithetic Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamEmpiricalAntitheticTestCase::DoRun (void)
+EmpiricalAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   // Create the RNG with a uniform distribution between 0 and 10.
@@ -2834,71 +2381,83 @@
     }
 
   // Calculate the mean of these values.
-  double sum = 0.0;
-  double value;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->Interpolate ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
-
+  double valueMean = Average (x);
+  // Expected
+  //    E[value] = 5 * 25%  + 10 * 75%  = 8.75
+  double expectedMean = 8.75;
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
+
+  // Check interpolated sampling
+  x->SetInterpolate (true);
+  valueMean = Average (x);
+  
   // The expected value for the mean of the values returned by this
-  // empirical distribution is
+  // empirical distribution with interpolation is
   //
   //     E[value]  =  2.5 * 25% + 7.5 * 75% = 6.25
   //
-  double expectedMean = 6.25;
+  expectedMean = 6.25;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-class RandomVariableStreamTestSuite : public TestSuite
+/**
+ * RandomVariableStream test suite, covering all random number variable
+ * stream generator types.
+ */ 
+class RandomVariableSuite : public TestSuite
 {
 public:
-  RandomVariableStreamTestSuite ();
+  // Constructor
+  RandomVariableSuite ();
 };
 
-RandomVariableStreamTestSuite::RandomVariableStreamTestSuite ()
+RandomVariableSuite::RandomVariableSuite ()
   : TestSuite ("random-variable-stream-generators", UNIT)
 {
-  AddTestCase (new RandomVariableStreamUniformTestCase);
-  AddTestCase (new RandomVariableStreamUniformAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamConstantTestCase);
-  AddTestCase (new RandomVariableStreamSequentialTestCase);
-  AddTestCase (new RandomVariableStreamNormalTestCase);
-  AddTestCase (new RandomVariableStreamNormalAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamExponentialTestCase);
-  AddTestCase (new RandomVariableStreamExponentialAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamParetoTestCase);
-  AddTestCase (new RandomVariableStreamParetoAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamWeibullTestCase);
-  AddTestCase (new RandomVariableStreamWeibullAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamLogNormalTestCase);
+  AddTestCase (new UniformTestCase);
+  AddTestCase (new UniformAntitheticTestCase);
+  AddTestCase (new ConstantTestCase);
+  AddTestCase (new SequentialTestCase);
+  AddTestCase (new NormalTestCase);
+  AddTestCase (new NormalAntitheticTestCase);
+  AddTestCase (new ExponentialTestCase);
+  AddTestCase (new ExponentialAntitheticTestCase);
+  AddTestCase (new ParetoTestCase);
+  AddTestCase (new ParetoAntitheticTestCase);
+  AddTestCase (new WeibullTestCase);
+  AddTestCase (new WeibullAntitheticTestCase);
+  AddTestCase (new LogNormalTestCase);
   /// \todo This test is currently disabled because it fails sometimes.
   /// A possible reason for the failure is that the antithetic code is
   /// not implemented properly for this log-normal case.
   /*
-  AddTestCase (new RandomVariableStreamLogNormalAntitheticTestCase);
+  AddTestCase (new LogNormalAntitheticTestCase);
   */
-  AddTestCase (new RandomVariableStreamGammaTestCase);
+  AddTestCase (new GammaTestCase);
   /// \todo This test is currently disabled because it fails sometimes.
   /// A possible reason for the failure is that the antithetic code is
   /// not implemented properly for this gamma case.
   /*
-  AddTestCase (new RandomVariableStreamGammaAntitheticTestCase);
+  AddTestCase (new GammaAntitheticTestCase);
   */
-  AddTestCase (new RandomVariableStreamErlangTestCase);
-  AddTestCase (new RandomVariableStreamErlangAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamZipfTestCase);
-  AddTestCase (new RandomVariableStreamZipfAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamZetaTestCase);
-  AddTestCase (new RandomVariableStreamZetaAntitheticTestCase);
-  AddTestCase (new RandomVariableStreamDeterministicTestCase);
-  AddTestCase (new RandomVariableStreamEmpiricalTestCase);
-  AddTestCase (new RandomVariableStreamEmpiricalAntitheticTestCase);
+  AddTestCase (new ErlangTestCase);
+  AddTestCase (new ErlangAntitheticTestCase);
+  AddTestCase (new ZipfTestCase);
+  AddTestCase (new ZipfAntitheticTestCase);
+  AddTestCase (new ZetaTestCase);
+  AddTestCase (new ZetaAntitheticTestCase);
+  AddTestCase (new DeterministicTestCase);
+  AddTestCase (new EmpiricalTestCase);
+  AddTestCase (new EmpiricalAntitheticTestCase);
 }
 
-static RandomVariableStreamTestSuite randomVariableStreamTestSuite;
+static RandomVariableSuite randomVariableSuite;
+
+}  // namespace RandomVariable
+
+}  // namespace test
+
+}  // namespace ns3
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/time-test-suite.cc ns-3.32/src/core/test/time-test-suite.cc
--- ns-3.31/src/core/test/time-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/time-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -20,26 +20,96 @@
  * TimeStep support by Emmanuelle Laprise <emmanuelle.laprise@bluekazoo.ca>
  */
 
+#include <array>
 #include <iomanip>
 #include <iostream>
 #include <string>
 #include <sstream>
+#include <tuple>
 
 #include "ns3/nstime.h"
 #include "ns3/int64x64.h"
 #include "ns3/test.h"
 
 using namespace ns3;
-
+/**
+ * \ingroup core-tests
+ * \brief time simple test case, Checks the basic operations on time
+ */
 class TimeSimpleTestCase : public TestCase
 {
 public:
+  /**
+   * \brief constructor for TimeSimpleTestCase.
+   */
   TimeSimpleTestCase ();
 
 private:
+  /**
+   * \brief setup function for TimeSimpleTestCase.
+   */
   virtual void DoSetup (void);
+
+  /**
+   * \brief Runs the Simple Time test case.
+   */
   virtual void DoRun (void);
+
+  /**
+   * \brief Tests the Time Operations.
+   */
+  virtual void DoTimeOperations (void);
+
+  /**
+   * \brief Does the tear down for TimeSimpleTestCase.
+   */
   virtual void DoTeardown (void);
+
+  /**
+   * Helper function to handle boilerplate code for multiplication tests
+   *
+   * \tparam T type of multiplication value
+   *  
+   * \param t Time value to multiply
+   * \param expected Expected result of the multiplication
+   * \param val Value to multiply by
+   * \param msg Error message to print if test fails
+   */
+  template<typename T>
+  void TestMultiplication (Time t, Time expected, T val, const std::string& msg); 
+
+  /**
+   * Test multiplying a Time instance by various integer types
+   */
+  void TestMultiplicationByIntegerTypes ();
+
+  /**
+   * Test multiplying a Time instance by various decimal types
+   */
+  void TestMultiplicationByDecimalTypes ();
+
+  /**
+   * Helper function to handle boilerplate code for division tests
+   *
+   * \tparam T type of division value
+   *
+   * \param t Time value to divide 
+   * \param expected Expected result of the divsion 
+   * \param val Value to divide by
+   * \param msg Error message to print if test fails
+   */
+  template<typename T>
+  void TestDivision(Time t, Time expected, T val, const std::string& msg);
+
+  /**
+   * Test dividing a Time instance by various integer types
+   */
+  void TestDivisionByIntegerTypes ();
+
+  /**
+   * Test dividing a Time instance by various decimal types
+   */
+  void TestDivisionByDecimalTypes ();
 };
 
 TimeSimpleTestCase::TimeSimpleTestCase ()
@@ -50,6 +120,40 @@
 TimeSimpleTestCase::DoSetup (void)
 {}
 
+void TimeSimpleTestCase::DoTimeOperations (void)
+{
+  // Test Multiplication
+  constexpr long long oneSec =  1000000000;  // conversion to default nanoseconds
+
+  // Time in seconds
+  ns3::Time t1 = Time (125LL * oneSec);
+  ns3::Time t2 = Time (2000LL * oneSec);
+
+  std::cout << "Testing Time Subtraction \n";
+
+  NS_TEST_ASSERT_MSG_EQ ( (t2 - t1).GetSeconds (), 1875, "Time Subtraction");
+
+  // Test Multiplication Operations:
+  std::cout << "Testing Time Multiplication \n";
+
+  TestMultiplicationByIntegerTypes ();
+  TestMultiplicationByDecimalTypes ();
+
+  // Test Division Operations:
+  std::cout << "Testing Time Division \n";
+
+  TestDivisionByIntegerTypes ();
+  TestDivisionByDecimalTypes ();
+
+  std::cout << "Testing modulo division \n";
+
+  t1 = Time (101LL * oneSec);
+  NS_TEST_ASSERT_MSG_EQ ( (t2 % t1).GetSeconds (), 81, "Remainder Operation (2000 % 101 = 81)" );
+  NS_TEST_ASSERT_MSG_EQ ( Div (t2,t1), 19, "Modular Divison");
+  NS_TEST_ASSERT_MSG_EQ ( Rem (t2,t1).GetSeconds (), 81, "Remainder Operation (2000 % 101 = 81)" );
+
+}
+
 void
 TimeSimpleTestCase::DoRun (void)
 {
@@ -77,6 +181,9 @@
                          "is 1ms really 1ms ?");
   NS_TEST_ASSERT_MSG_EQ (MicroSeconds (1).GetMicroSeconds (), 1,
                          "is 1us really 1us ?");
+
+  DoTimeOperations ();
+
 #if 0
   Time ns = NanoSeconds (1);
   ns.GetNanoSeconds ();
@@ -100,14 +207,154 @@
 TimeSimpleTestCase::DoTeardown (void)
 {}
 
+template<typename T>
+void 
+TimeSimpleTestCase::TestMultiplication (Time t, Time expected, T val, 
+                                       const std::string& msg) 
+                      
+{
+  using TestEntry = std::tuple<Time, std::string>;
+  std::array<TestEntry, 2> TESTS{ 
+      std::make_tuple (t * val, "Test Time * value: "),
+      std::make_tuple (val * t, "Test Time * value: ")
+  };
+  
+  for (auto test: TESTS )
+  {
+    std::string errMsg = std::get<1> (test) + msg;
+  
+    NS_TEST_ASSERT_MSG_EQ (std::get<0> (test), expected, errMsg);
+  }
+}
+
+void
+TimeSimpleTestCase::TestMultiplicationByIntegerTypes ()
+{
+  int sec = 125;
+  int scale = 100; 
+
+  Time t = Seconds (sec);
+  Time expected = Time (t.GetTimeStep () * scale); 
+
+  TestMultiplication (t, expected, static_cast<char> (scale), "Multiplication by char");
+  TestMultiplication (t, expected, static_cast<unsigned char> (scale), 
+                     "Multiplication by unsigned char");
+  TestMultiplication (t, expected, static_cast<short> (scale), "Multiplication by short");
+  TestMultiplication (t, expected, static_cast<unsigned short> (scale), 
+                     "Multiplication by unsigned short");
+  TestMultiplication (t, expected, static_cast<int> (scale), "Multiplication by int");
+  TestMultiplication (t, expected, static_cast<unsigned int> (scale), 
+                     "Multiplication by unsigned int");
+  TestMultiplication (t, expected, static_cast<long> (scale), "Multiplication by long");
+  TestMultiplication (t, expected, static_cast<unsigned long> (scale), 
+                     "Multiplication by unsigned long");
+  TestMultiplication (t, expected, static_cast<long long> (scale), 
+                     "Multiplication by long long");
+  TestMultiplication (t, expected, static_cast<unsigned long long> (scale), 
+                     "Multiplication by unsigned long long");
+  TestMultiplication (t, expected, static_cast<std::size_t> (scale), 
+                     "Multiplication by size_t");
+
+  int64x64_t scale64 = 100;
+  TestMultiplication (t, expected, scale64, "Multiplication by int64x64_t");
+}
+
+void
+TimeSimpleTestCase::TestMultiplicationByDecimalTypes ()
+{
+  float sec = 150.0;
+  float scale = 100.2; 
+
+  Time t = Seconds (sec);
+  Time expected = Time (t.GetDouble () * scale); 
+
+  TestMultiplication (t, expected, scale, "Multiplication by float");
+  TestMultiplication (t, expected, static_cast<double> (scale), 
+                     "Multiplication by double");
+}
+
+template<typename T>
+void 
+TimeSimpleTestCase::TestDivision (Time t, Time expected, T val, const std::string& msg)
+{
+  Time result = t / val;
+
+  NS_TEST_ASSERT_MSG_EQ (result, expected, msg);
+}
+
+void 
+TimeSimpleTestCase::TestDivisionByIntegerTypes()
+{
+  int sec = 2000;
+  int scale = 100; 
+
+  Time t = Seconds (sec);
+  Time expected = Time (t.GetTimeStep () / scale);
+
+  TestDivision (t, expected, static_cast<char> (scale), "Division by char");
+  TestDivision (t, expected, static_cast<unsigned char> (scale), 
+                     "Division by unsigned char");
+  TestDivision (t, expected, static_cast<short> (scale), "Division by short");
+  TestDivision (t, expected, static_cast<unsigned short> (scale), 
+                     "Division by unsigned short");
+  TestDivision (t, expected, static_cast<int> (scale), "Division by int");
+  TestDivision (t, expected, static_cast<unsigned int> (scale), 
+                     "Division by unsigned int");
+  TestDivision (t, expected, static_cast<long> (scale), "Division by long");
+  TestDivision (t, expected, static_cast<unsigned long> (scale), 
+                     "Division by unsigned long");
+  TestDivision (t, expected, static_cast<long long> (scale), 
+                     "Division by long long");
+  TestDivision (t, expected, static_cast<unsigned long long> (scale), 
+                     "Division by unsigned long long");
+  TestDivision (t, expected, static_cast<std::size_t> (scale), 
+                     "Division by size_t");
+
+  int64x64_t scale64 = 100;
+  TestDivision (t, expected, scale64, "Division by int64x64_t");
+}
+
+void 
+TimeSimpleTestCase::TestDivisionByDecimalTypes ()
+{
+  float sec = 200.0;
+  float scale = 0.2; 
+
+  Time t = Seconds (sec);
+  Time expected = t / int64x64_t (scale);
+
+  TestDivision (t, expected, scale, "Division by float");
+  TestDivision (t, expected, static_cast<double> (scale), 
+                     "Division by double");
+}
+
+
+/**
+ * \ingroup core-tests
+ * \brief  time-tests Time with Sign test case
+ */
 class TimeWithSignTestCase : public TestCase
 {
 public:
+  /**
+   * \brief constructor for TimeWithSignTestCase.
+   */
   TimeWithSignTestCase ();
 
 private:
+  /**
+   * \brief DoSetup for TimeWithSignTestCase.
+   */
   virtual void DoSetup (void);
+
+  /**
+   * \brief DoRun for TimeWithSignTestCase.
+   */
   virtual void DoRun (void);
+
+  /**
+   * \brief DoTeardown for TimeWithSignTestCase.
+   */
   virtual void DoTeardown (void);
 };
 
@@ -149,18 +396,32 @@
                              "Negative time with units not parsed correctly.");
 }
 
+
 void
 TimeWithSignTestCase::DoTeardown (void)
 {}
 
-
+/**
+ * \ingroup core-tests
+ * \brief Input output Test Case for Time
+ */
 class TimeInputOutputTestCase : public TestCase
 {
 public:
+  /**
+   * \brief Constructor for TimeInputOutputTestCase.
+   */
   TimeInputOutputTestCase ();
 
 private:
+  /**
+   * \brief DoRun for TimeInputOutputTestCase.
+   */ 
   virtual void DoRun (void);
+  /**
+   * \brief Check test case.
+   * \param str Time input check.
+   */
   void Check (const std::string & str);
 };
 
@@ -226,6 +487,10 @@
   std::cout << std::endl;
 }
 
+/**
+* \ingroup core-tests
+* \brief   Time test Suite.  Runs the appropriate test cases for time
+*/
 static class TimeTestSuite : public TestSuite
 {
 public:
@@ -237,6 +502,6 @@
     // This should be last, since it changes the resolution
     AddTestCase (new TimeSimpleTestCase (), TestCase::QUICK);
   }
-} g_timeTestSuite;
-
-
+}
+/** \brief Member variable for time test suite */
+g_timeTestSuite;
